SIGINTERRUPT(3P)

NAME
siginterrupt - allow signals to interrupt functions

SYNOPSIS

#include <signal.h>

int siginterrupt(int sig, int flag);

DESCRIPTION

The siginterrupt() function shall change the restart behavior when a function is interrupted by the specified signal. The function siginterrupt(sig, flag) has an effect as if implemented as:

    int siginterrupt(int sig, int flag) {
        int ret;
        struct sigaction act;

        (void) sigaction(sig, NULL, &act);
        if (flag)
            act.sa_flags &= ~SA_RESTART;
        else
            act.sa_flags |= SA_RESTART;
        ret = sigaction(sig, &act, NULL);
        return ret;
    }

RETURN VALUE

Upon successful completion, siginterrupt() shall return 0; otherwise, -1 shall be returned and errno set to indicate the error.

ERRORS

The siginterrupt() function shall fail if:

EINVAL
    The sig argument is not a valid signal number.

The following sections are informative.

EXAMPLES

None.

APPLICATION USAGE

The siginterrupt() function supports programs written to historical system interfaces. A conforming application, when being written or rewritten, should use sigaction() with the SA_RESTART flag instead of siginterrupt().

RATIONALE

None.

FUTURE DIRECTIONS

None.

SEE ALSO

Signal Concepts , sigaction() , the Base Definitions volume of IEEE Std 1003.1-2001, <signal.h>

COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .